require 'thread'

class List

class Item
  @field_name = []
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end

  attr_reader :key
  attr_reader :fields
    def Item.new_key
      require 'digest/md5'
      md5 = Digest::MD5::new
      md5.update(String(Time::now))
      md5.update(String(rand(0)))
      md5.update(String($$))
      md5.update('foobar')
      md5.hexdigest[0,16]
    end
  def initialize(key, *fields)
    @fields = fields
    @key = key || Item.new_key
  end
  def self.new_from_str(str)
    key, *fields = str.split(/\t/)
    self.new(key, *fields)
  end
  def to_s
    [@key, *@fields].map{|i| String(i).tr("\t"," ") }.join("\t")
  end
  def field_name_at(idx)
    self.class.field_name[idx] || :unknown
  end
  def to_hash
    hash = { :key => @key }
    @fields.each_with_index do |field, idx|
      hash[field_name_at(idx)] = field
    end
    hash
  end
  def edit(*fields)
    @fields.each_with_index do |field, idx|
      @fields[idx] = fields[idx] if fields[idx]
    end
  end
end

  @dir = 'list_db'
  def self.dir
    @dir
  end
  def self.dir=(dir)
    @dir = dir
  end

  @item_class = Item
  def self.item_class
    @item_class
  end
  def self.item_class=(item_class)
    @item_class = item_class
  end

  attr_reader :item
  def initialize
    @item = []
    @mutex = Mutex.new
    load
  end

  def add(*fields)
    item = self.class.item_class.new(nil, *fields)
    @item.push item
    save item
    item
  end

  def edit(key, *fields)
    item = find(key)
    item.edit(*fields)
    save item
    item
  end

  def remove(key)
    item = find(key)
    if item
      @item.delete item
      delete item
    end
    item
  end

  def find(key)
    @item.find{|item| item.key == key }
  end

  def fetch_hash_all
    @item.map{|item| item.to_hash }
  end

  def fetch_hash(key)
    item = find(key)
    return nil unless item
    item.to_hash
  end

private
  def load
    @mutex.synchronize do
      Dir.glob(File.join(self.class.dir, '*')) do |entry|
        File.open(entry, "rb") do |f|
          item = self.class.item_class.new_from_str(f.read)
          @item.push item
        end
      end
    end
  end
  def save(item)
    @mutex.synchronize do
      File.open(File.join(self.class.dir, item.key), "wb") do |f|
        f.print item
      end
    end
  end
  def delete(item)
    @mutex.synchronize do
      File.delete File.join(self.class.dir, item.key)
    end
  end
end

