require 'list'

class ListProducer < Web::Producer
  set_erb('list.erb')
  @field_name = List::Item.field_name
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end
  @field_caption = {}
  def self.field_caption
    @field_caption
  end
  def self.field_caption=(caption)
    @field_caption = caption
  end
  @caption = 'List'
  def self.caption
    @caption
  end
  def self.caption=(caption)
    @caption = caption
  end
  def initialize(session, list)
    super(session)
    @list = list
    @mode = :browse
  end
  def add(*fields)
    @list.add(*fields)
  end
  def edit(key, *fields)
    @list.edit(key, *fields)
  end
  def remove(key)
    @list.remove(key)
  end
  def do_add(context, params)
      fields = self.class.field_name.map{|name| params[name.to_s] }
      add(*fields)
  end
  def do_edit(context, params)
    case @mode
    when :browse
      key, = params['key']
      @currkey = key
      @mode = :edit
    when :edit
      key, = params['key']
      fields = self.class.field_name.map{|name| params[name.to_s] }
      edit(key, *fields)
      @mode = :browse
    end
  end
  def do_remove(context, params)
      key, = params['key']
      remove(key)
  end
  def browse
      @mode = :browse
  end
  def hide
      @mode = :hide
  end
  def do_browse(context, params)
      browse
  end
  def do_hide(context, params)
      hide
  end
end

